abstract class Moving {
  Enemy e;
  Moving(){}
  void set(Enemy enemy){
    this.e = enemy;
    init();
  }
  void init(){}
  abstract void update(boolean attacking);
}
class Straight extends Moving{
  void update(boolean attacking){
    if(attacking ==false){
      e.fx += e.vx;
      e.fy += e.vy;
    }
  }
}
class Homing extends Moving{
  float si,co;
  Homing(float drad){
    super();
    si = sin(drad);
    co = cos(drad);
  }
  void update(boolean attacking){
    float temp;
    float in = (ship.fx - e.fx) * -e.vy + (ship.fy - e.fy) * e.vx;
    if(in < 0){
      temp = e.vx;
      e.vx = temp * co + e.vy * si;
      e.vy = - temp * si + e.vy * co;
      
    }else{      
      temp = e.vx;
      e.vx = temp * co - e.vy * si;
      e.vy = temp * si + e.vy * co;
      
    }
    if(attacking ==false){
      e.fx += e.vx;
      e.fy += e.vy;
    }
    
  }
}
class Dart extends Moving{
  float si,co;
  Dart(float drad){
    super();
    si = sin(drad);
    co = cos(drad);
  }
  void update(boolean attacking){
    if(attacking ==false){
      e.fx += e.vx;
      e.fy += e.vy;
    }else{
      float temp;
      float in = (ship.fx - e.fx) * -e.vy + (ship.fy - e.fy) * e.vx;
      if(in < 0){
        temp = e.vx;
        e.vx = temp * co + e.vy * si;
        e.vy = - temp * si + e.vy * co;
      
      }else{      
        temp = e.vx;
        e.vx = temp * co - e.vy * si;
        e.vy = temp * si + e.vy * co;
      
      }
    }
    
    
  }
}
