class Shape implements Cloneable{
   float[] x;
   float[] y;
   float[] z;
   Shape(){
    
  }
   Shape(float[] x,float[] y,float[] z){
    this.x =(float[])x.clone();
    this.y =(float[])y.clone();
    this.z =(float[])z.clone();
  }
   void multi(float mul){
    x = multiple(x ,mul);
    y = multiple(y ,mul);
    z = multiple(z ,mul);
  }
   Object clone(){
    Shape shape = new Shape(x ,y ,z);
    
    return shape;
  }
}
class Pole extends Shape{
   Pole(float[][] a ,float[][] b ,int segment){
    if(a.length != b.length || a.length < 1){
      System.out.println("Pole arguments error");
      System.exit(1);
    }
    int maxNum = 0;
    for(int i = a.length -1;0 <= i;i --){
      if(a[i].length != b[i].length || a[i].length < 1){
        System.out.println("Pole arguments error");
        System.exit(1);
      }
      if(maxNum < a[i].length)maxNum = a[i].length;
    }
    float[][] x0 = new float[segment][maxNum];
    float[][] y0 = new float[segment][maxNum];
    float[][] z0 = new float[segment][maxNum];
    int k,l;
    k = 0;
    
    for(int i = 0;i < segment ;i ++){
      for(int j = 0;j < maxNum ;j ++){
        if(j < a[k].length)l = j;
        else l = a[k].length - 1;
        x0[i][j] = a[k][l];
        y0[i][j] = b[k][l] * cos((float)i / (float)segment * TWO_PI);
        z0[i][j] = b[k][l] * sin((float)i / (float)segment * TWO_PI);
      }
      k ++;
      if(a.length <= k)k = 0;
    }
    int number = (2 * segment + 1) * maxNum;
    x = new float[number];
    y = new float[number];
    z = new float[number];
    int num = 0;
    
    for(int j = 0;j < maxNum ;j ++){
      x[num] = x0[0][j];
      y[num] = y0[0][j];
      z[num] = z0[0][j];
      num ++;
      for(int i = 0;i < segment ;i ++){
        x[num] = x0[i][j];
        y[num] = y0[i][j];
        z[num] = z0[i][j];
        num ++;
      }
      
      x[num] = x0[0][j];
      y[num] = y0[0][j];
      z[num] = z0[0][j];
      num ++;
    }
    
    int seg = 0;
    while(true){
      seg ++;
      if(segment <= seg)break; 
      for(int j = maxNum - 1;0 <= j ;j --){
        x[num] = x0[seg][j];
        y[num] = y0[seg][j];
        z[num] = z0[seg][j];
        num ++;
      }
      seg ++;
      if(segment <= seg)break; 
      for(int j = 0;j < maxNum ;j ++){
        x[num] = x0[seg][j];
        y[num] = y0[seg][j];
        z[num] = z0[seg][j];
        num ++;
      }
    }
    
  }
   Pole(float[] a ,float[] b ,int segment){
    if(a.length != b.length || a.length < 1){
      System.out.println("Pole arguments error");
      System.exit(1);
    }
    float[][] x0 = new float[segment][a.length];
    float[][] y0 = new float[segment][a.length];
    float[][] z0 = new float[segment][a.length];
    for(int i = 0;i < segment ;i ++){
      for(int j = 0;j < a.length ;j ++){
        x0[i][j] = a[j];
        y0[i][j] = b[j] * cos((float)i / (float)segment * TWO_PI);
        z0[i][j] = b[j] * sin((float)i / (float)segment * TWO_PI);
      }
    }
    int number = (2 * segment + 1) * a.length;
    x = new float[number];
    y = new float[number];
    z = new float[number];
    int num = 0;
    
    for(int j = 0;j < a.length ;j ++){
      x[num] = x0[0][j];
      y[num] = y0[0][j];
      z[num] = z0[0][j];
      num ++;
      for(int i = 0;i < segment ;i ++){
        x[num] = x0[i][j];
        y[num] = y0[i][j];
        z[num] = z0[i][j];
        num ++;
      }
      
      x[num] = x0[0][j];
      y[num] = y0[0][j];
      z[num] = z0[0][j];
      num ++;
    }
    
    int seg = 0;
    while(true){
      seg ++;
      if(segment <= seg)break; 
      for(int j = a.length - 1;0 <= j ;j --){
        x[num] = x0[seg][j];
        y[num] = y0[seg][j];
        z[num] = z0[seg][j];
        num ++;
      }
      seg ++;
      if(segment <= seg)break; 
      for(int j = 0;j < a.length ;j ++){
        x[num] = x0[seg][j];
        y[num] = y0[seg][j];
        z[num] = z0[seg][j];
        num ++;
      }
    }
  }
}
class Symmentry extends Shape{
   Symmentry(float[] a ,float[] b ,int segment){
    if(a.length != b.length || a.length < 1){
      System.out.println("Pole arguments error");
      System.exit(1);
    }
    float[][] x0 = new float[segment][a.length];
    float[][] y0 = new float[segment][a.length];
    float[][] z0 = new float[segment][a.length];
    for(int i = 0;i < segment ;i ++){
      for(int j = 0;j < a.length ;j ++){
        x0[i][j] = a[j];
        y0[i][j] = b[j] * cos((float)i / (float)segment * TWO_PI);
        z0[i][j] = b[j] * sin((float)i / (float)segment * TWO_PI);
      }
    }
    int number = segment * a.length;
    x = new float[number];
    y = new float[number];
    z = new float[number];
    int num = 0;
    
    int seg = 0;
    while(true){
      
      if(segment <= seg)break; 
      for(int j = a.length - 1;0 <= j ;j --){
        x[num] = x0[seg][j];
        y[num] = y0[seg][j];
        z[num] = z0[seg][j];
        num ++;
      }
      seg ++;
      if(segment <= seg)break; 
      for(int j = 0;j < a.length ;j ++){
        x[num] = x0[seg][j];
        y[num] = y0[seg][j];
        z[num] = z0[seg][j];
        num ++;
      }
      seg ++;
    }
  }
}
