
class Ship{
  final float RECMAX = 100;
  final float SPEED = 7.0;
  final int MAXSHIELD = 5;
  float x , y ,z;
  float fx ,fy ,fz;
  float size;
  float[] px = new float[MAXSHIELD];
  float[] py = new float[MAXSHIELD];
  float[] pz = new float[MAXSHIELD];
  float[] psize = new float[MAXSHIELD];
  float[] aim = new float[2];
  Gun gun;
  int shield;
  float recGauge;
  int recCnt;
  int damCnt;
  boolean recovering;
  private Shape shape;
  private float dam;
  private int invTime;
   Ship(){
    gun = new Gun();
    init();
    float[] a = {-10 ,-20 ,30, 40 ,20 ,-5 ,5 ,30};
    float[] b = {0 ,20 ,30 ,25 ,23 ,15 ,5 ,0};
    shape = new Symmentry(a ,b ,4);
  }
   void init(){
    gun.init();
    aim[0] = 1.0f;
    aim[1] = 0.0f;
    x = 0;
    y = 0;
    z = 0;
    size = 1.0f;
    for(int i = MAXSHIELD -1;0 <= i;i --){
      px[i] = x;
      py[i] = y;
      pz[i] = z;
      psize[i] = size;
    }
    fx = 0;
    fy = 0;
    fz = 0;
    dam = 0;
    damCnt = 0;
    invTime = 0;
    shield = MAXSHIELD;
    recGauge = 0;
    recCnt = 0;
    recovering = false;
  }
   void update(){
    for(int i = MAXSHIELD -1;1 <= i;i --){
      px[i] = px[i-1];
      py[i] = py[i-1];
      pz[i] = pz[i-1];
      psize[i] = psize[i-1];
    }
    px[0] = x;
    py[0] = y;
    pz[0] = z;
    psize[0] = size;
    float pox = pointer.fx;
    float poy = pointer.fy;
    float r = dist(fx ,fy ,pox ,poy );
    float r1 = 70;
    float r2 = 150;
    if(0.0f < r){
      aim[0] = (pox - x) / r;
      aim[1] = (poy - y) / r;
      if(r < r1);
      else{ 
        if(r < r2){
          fx += aim[0] * SPEED;
          fy += aim[1] * SPEED;
        }else{
          fx += aim[0] * SPEED * 2.0f;
          fy += aim[1] * SPEED * 2.0f;
        }
      }
      
    }
    float fr = dist(fx ,fy ,field.x ,field.y );
    if(field.radius < fr){
      fx = (fx -field.x) * (field.radius / fr) + field.x;
      fy = (fy -field.y) * (field.radius / fr) + field.y;
    }
    x = field.transX(fx ,fy ,fz);
    y = field.transY(fx ,fy ,fz);
    z = field.transZ(fx ,fy ,fz);
    size = 0.8 + (float)(TEMPO - frameCount % TEMPO) / (float)TEMPO  * 0.2 * max(float(shield) ,0) / float(MAXSHIELD);
    
    cam.update();
    cam.setCamera();
    scale(height / 480);
    pushMatrix();
    //x = mouseX;
    //y = mouseY;
    float[] ax = shape.x;
    float[] ay = shape.y;
    float[] az = shape.z;
    float sx = dam * random(5.0f);
    float sy = dam * random(5.0f);
    float sz = dam * random(5.0f);
    
    noFill();
   if(recovering){
     recCnt --;
     if(recCnt <= 0){
       recovering = false;
       shield ++;
     }
     pushMatrix();
     stroke(122);
     translate(x ,y ,z );
     
     scale(sqrt(recCnt * 10 + 1));
     sphereDetail(4);
     sphere(20);
     popMatrix();
    }
    if(0 < damCnt){
     damCnt --;
     pushMatrix();
     stroke(122);
     
     translate(x ,y ,z );
     
     scale(sqrt((30 - damCnt) * 20 + 1));
     sphereDetail(4);
     sphere(20);
     popMatrix();
   }
    stroke(155 + max(shield  ,0) * 100 / MAXSHIELD);
     
    translate(x ,y ,z );
    //ellipse(0 ,0 ,r1 * 2 ,r1 * 2);
    //ellipse(0 ,0 ,r2 * 2 ,r2 * 2);
    
   
    for(int i = MAXSHIELD - 1;0 <= i;i --){
      if(i < shield)stroke(255);
      else stroke(122);
      arc(0 ,0 ,r1 * 2 ,r1 * 2 ,(PI * 3.0 / 2.0 + TWO_PI / float(MAXSHIELD) * float(i)) ,(-PI / 2 + TWO_PI / float(MAXSHIELD) * float(i + 1)));
    }
    if(0 < recGauge){
      stroke(255);
      arc(0 ,0 ,r2 * 2 ,r2 * 2 ,(PI * 3.0 / 2.0) ,(PI * 3.0 / 2.0 + TWO_PI / RECMAX * recGauge));
      stroke(122);
      arc(0 ,0 ,r2 * 2 ,r2 * 2 ,(PI * 3.0 / 2.0 + TWO_PI / RECMAX * recGauge) ,(-PI / 2 + TWO_PI));
    }else{
      stroke(122);
      ellipse(0 ,0 ,r2 * 2 ,r2 * 2);
    }
    stroke(155 + max(shield  ,0) * 100 / MAXSHIELD);
    translate(sx ,sy ,sz);
    scale(size);
    sphereDetail(4);
    sphere(20);
    stroke(1);
    
    gun.update(aim);
    if(dam > 0)dam -= 1.0f;
    else dam = 0;
    if(invTime > 0)invTime --;
    else invTime = 0;
  }
  void inTitle(){
    fx = 0;
    fy = 0;
    fz = 0;
    float sx = dam * random(5.0f);
    float sy = dam * random(5.0f);
    float sz = dam * random(5.0f);
    float r1 = 70;
    float r2 = 150;
    x = field.transX(fx ,fy ,fz);
    y = field.transY(fx ,fy ,fz);
    z = field.transZ(fx ,fy ,fz);
    cam.update();
    cam.setCamera();
    scale(height / 480);
    
    size = 0.8 + (float)(TEMPO - frameCount % TEMPO) / (float)TEMPO  * 0.2 * max(float(shield) ,0) / float(MAXSHIELD);
    float[] ax = shape.x;
    float[] ay = shape.y;
    float[] az = shape.z;
    
    noFill();
    if(recovering){
     recCnt --;
     if(recCnt <= 0){
       recovering = false;
       shield ++;
     }
 
     stroke(122);
     translate(x ,y ,z );
     pushMatrix();
     scale(sqrt(recCnt * 10 + 1));
     sphereDetail(4);
     sphere(20);
     popMatrix();
    }
    if(0 < damCnt){
     damCnt --;
     pushMatrix();
     stroke(122);
     
     translate(x ,y ,z );
     
     scale(sqrt((30 - damCnt) * 20 + 1));
     sphereDetail(4);
     sphere(20);
     popMatrix();
   }
    translate(x ,y ,z );
    //ellipse(0 ,0 ,r1 * 2 ,r1 * 2);
    //ellipse(0 ,0 ,r2 * 2 ,r2 * 2);
    
   
    for(int i = MAXSHIELD - 1;0 <= i;i --){
      if(i < shield)stroke(255);
      else stroke(122);
      arc(0 ,0 ,r1 * 2 ,r1 * 2 ,(PI * 3.0 / 2.0 + TWO_PI / float(MAXSHIELD) * float(i)) ,(-PI / 2 + TWO_PI / float(MAXSHIELD) * float(i + 1)));
    }
    if(0 < recGauge){
      stroke(255);
      arc(0 ,0 ,r2 * 2 ,r2 * 2 ,(PI * 3.0 / 2.0) ,(PI * 3.0 / 2.0 + TWO_PI / RECMAX * recGauge));
      stroke(122);
      arc(0 ,0 ,r2 * 2 ,r2 * 2 ,(PI * 3.0 / 2.0 + TWO_PI / RECMAX * recGauge) ,(-PI / 2 + TWO_PI));
    }else{
      stroke(122);
      ellipse(0 ,0 ,r2 * 2 ,r2 * 2);
    }
    stroke(155 + max(shield  ,0) * 100 / MAXSHIELD);
    scale(size);
    translate(sx ,sy ,sz);
    sphereDetail(4);
    sphere(20);
    stroke(1);
    if(dam > 0)dam -= 1.0f;
    else dam = 0;
    if(invTime > 0)invTime --;
    else invTime = 0;
  }
  void damage(float power){
    if(invTime <= 0){
      ep.allDamage(10);
      dam += power;
      damCnt = 30;
      shield --;
      System.out.println(shield);
      invTime = 15;
    }
  }
  void recPlus(float value){
    recGauge += value;
    if(RECMAX < recGauge && recovering == false){
      recovery();
      recGauge -= RECMAX;
      //System.out.println(shield);
    }
    //System.out.println(recGauge);
  }
  void recovery(){
    if(shield < 5){
      recovering = true;
      recCnt = 30;
    }else shield = 5;
    
  }
}
class Gun {
  private Shape shape;
  private int bulCnt;
  Enemy lock;
   Gun(){
    float[] a = {-10 ,0 ,18 ,30};
    float[] b = {0 ,10 ,6 ,0};
    shape = new Pole(a ,b ,5);
    
  }
  void init(){
    bulCnt = 0;
    lock = null;
  }
   void update(float[] aim){
    //System.out.println(lock);
    bulCnt --;
    float[] ax = shape.x;
    float[] ay = shape.y;
    float[] az = shape.z;
    if(mousePressed){
      bulCnt = 10;
    }else {
      lock = null;
      sp.release();
    }
    float[] daim =new float[2];
    float dtheta = TWO_PI * (1.0 - random(2.0)) / 30.0;
    daim[0] = aim[0] * cos(dtheta) + aim[1] * sin(dtheta);
    daim[1] = aim[1] * cos(dtheta) + aim[0] * sin(dtheta);
    if(0 <= bulCnt){
      if(lock != null){
        if(lock.isExist() == false || lock.destroyed){
          sp.shot(ship.fx ,ship.fy ,daim[0] * 40.0f ,aim[1] *40.0f);
          lock = null;
        }else {
          float r = dist(ship.fx ,ship.fy ,lock.fx ,lock.fy );
          sp.shot(ship.fx ,ship.fy ,(lock.fx - ship.fx) / r * 40.0f ,(lock.fy - ship.fy) / r * 40.0f);
        }
      }
      else sp.shot(ship.fx ,ship.fy ,daim[0] * 40.0f ,daim[1] *40.0f);
    }
    
    if(lock != null){
      popMatrix();
      pushMatrix();
      stroke(255);
      
      //strokeCap(ROUND);
      noFill();
      translate(lock.x + lock.sx,lock.y + lock.sy,lock.z + lock.sz);
      strokeWeight(4);
      rect(- 40 ,- 40 ,80 ,80);
      strokeWeight(1);
/*
      pushMatrix();      
      rotateZ(TWO_PI * (float)frameCount / 60.0);
      translate(lock.size + 20 ,0 ,0);
      box(10);
      popMatrix();
      rotateZ(TWO_PI * (float)frameCount / 60.0 + PI);
      translate(lock.size + 20 ,0 ,0);
      box(10);
      */
    }
    /*
    if(aim[0] > 0){
      rotateZ(atan(aim[1]/aim[0]));
    }else{
      rotateZ(atan(aim[1]/aim[0]) + PI);
    }
    rotateX(PI * frameCount / 120.0f);
    translate (40 ,0);
    beginShape(LINE_LOOP);
    for(int i = 0; i < ax.length ;i ++){
      vertex(ax[i] ,ay[i] ,az[i]);
    }
    endShape();
    */
  }
}
