class Stage{
  int level;
  int levCnt;
  float wait;
  float rank;
  float delay;
  void init(int level){
    this.level = level;
    wait = 60;
    delay = 0;
    levCnt = 0;
    setRank(level);
  }
  void update(){
    
    if(wait < delay){
      int[][] eLevList ={
        {1 ,2},
        {0 ,5},
        {3 ,6},
        {4}
      };
      float eLev = (rank - 1) * 10;
      float w = 0;
      while(wait < (rank - 1) * 500.0){
        int lv = floor(random(constrain(eLev,0 ,eLevList.length)));
        while(eLevList[lv].length == 0){
          lv --;
          if(lv < 0)return;
        }
        int type = eLevList[lv][floor(random(eLevList[lv].length))];
        float theta = random(TWO_PI);
        float aim = random(TWO_PI);
      //ep.addEnemy(null ,type ,new Homing(TWO_PI / 180) ,100 ,cos(theta) * (field.radius - 100) ,sin(theta) * (field.radius - 100) ,-400 ,- cos(aim) * 5.0 ,- sin(aim) * 5.0);
        switch(type){
          case 0:
          ep.addEnemy(null ,ICEBERG ,new Dart(TWO_PI / 180.0) ,20 ,cos(theta) * (field.radius - 200) ,sin(theta) * (field.radius - 200) ,-400 ,- cos(theta) * 5.0 ,- sin(theta) * 5.0);
          w = 40.0;
          break;
          case 1:
          ep.addEnemy(null ,NIGHTWING ,new Homing(TWO_PI / 180) ,80 ,cos(theta) * (field.radius - 100) ,sin(theta) * (field.radius -100) ,-400 ,- cos(aim) * 5.0 ,- sin(aim) * 5.0);
          w = 200.0;
          break;
          case 2:
          ep.addEnemy(null ,PLANE ,new Dart(TWO_PI / 90) ,30 ,cos(theta) * (field.radius + 400) ,sin(theta) * (field.radius + 400) ,0 ,- cos(theta) * 6.0 ,- sin(theta) * 6.0);
          w = 80.0;
          break;
          case 3:
          ep.addEnemy(null ,THREEWAY ,new Homing(TWO_PI / 180) ,60 ,cos(theta) * (field.radius - 100) ,sin(theta) * (field.radius - 100) ,-400 ,- cos(aim) * 5.0 ,- sin(aim) * 5.0);
          w = 200.0;
          break;
          case 4:
          ep.addEnemy(null ,FOURWAY ,new Homing(TWO_PI / 180) ,80 ,cos(theta) * (field.radius - 100) ,sin(theta) * (field.radius - 100) ,-400 ,- cos(aim) * 5.0 ,- sin(aim) * 5.0);
          w = 200.0;
          break;
          case 5:
          ep.addEnemy(null ,SCATTER ,new Homing(TWO_PI / 180) ,80 ,cos(theta) * (field.radius - 100) ,sin(theta) * (field.radius - 100) ,-400 ,- cos(theta) * 5.0 ,- sin(theta) * 5.0);
          w = 200.0;
          break;
          case 6:
          ep.addEnemy(null ,SWINE ,new Dart(TWO_PI / 45) ,10 ,cos(theta) * (field.radius + 400) ,sin(theta) * (field.radius + 400) ,0 ,- cos(theta) * 9.0 ,- sin(theta) * 9.0);
          w = 30.0;
          break;
        }
        wait += w;
        eLev -= w / 100;
        if(random(1) < 0.5)break;
      }
    }
    wait -= sqrt(rank);
    delay = (1 - random(2)) * rank * 30;
    levCnt ++;
    if(180 < levCnt){
      level ++;
      setRank(level);
      levCnt = 0;
    }
  }
  void setRank(int level){
    int lev1 = (level - 1) % 10;
    int lev10 = (level - 1) / 10;
    rank = 1 + float(lev1) * (0.02 + float(lev10) * 0.001) + float(lev10) * 0.04;
    //System.out.println(rank);
  }
}
